#include once "VmStackMemory.bi"
ENUM OperandFlags
        _NONE=0
        _ImmOrDisplacement = 1
        _Register = 2
        _Ptr = 4

        _Bit8=8
        _Bit16=16
        _Bit32=32

        _RegisterImmediateValue = 3
        _ImmediatePointer=5
        _RegisterPointer =6
        _RegisterDisplacement=7
END ENUM

ENUM Prefix
        _NULL=0
        _REP=1
END ENUM

ENUM OPCode
		_NOP = 0

        _MOV = 1
        '//Clear des flags
        _CLE = 2  '//clear "EQUAL flag"
        _CLA = 3  '//clear "ABOVE flag"
        _CLB = 4  '//clear "BELOW flag"
        _CLZ = 5  '//clear "zero flag"       
        '//set des flags
        _SLE = 6  '//Set "EQUAL flag"
        _SLA = 7  '//Set "ABOVE flag"
        _SLB = 8  '//Set "BELOW flag"
        _SLZ = 9  '//Set "zero flag"    

        '//conversion
        _ITOS = 10	'// convert from signed integer to float
        _STOI = 11	'//convert from float to signed integer

        '//arithmtiques
        _ADD = 12
        _FADD = 13
        _SUB = 14
        _FSUB = 15
        _MUL = 16
        _FMUL = 17
        _DIV = 18
        _FDIV = 19
        _INC = 20
        _FINC = 21
        _DEC = 22
        _FDEC = 23

        '//boucles et saut
        _LOOP = 24
        _JMP = 25
        _JE = 26
        _JNE = 27
        _JA = 28
        _JNA = 29
        _JB = 30
        _JNB = 31
        _JAE = 32
        _JNAE = 33
        _JBE = 34
        _JNBE = 35

        '//Logique
        _AND = 36
        _OR = 37
        _XOR = 38
        _NEG = 39
        _NOT = 40

        '//binaire
        _SHR = 41
        _SHL = 42

        '// pile
        _PUSH = 43
        _POP = 44
        _PUSHF = 45
        _POPF = 46
        _PUSHA = 47
        _POPA = 48
        
        '// call
        _XCALL = 49
        _CALL = 50
        _RET = 51

        '//comparaison
        _CMP = 52

        '// interruption
        _INT = 53
        _HLT = 54
       
        '//Load module
        _LMOD = 55
end ENUM

ENUM Registers
        '//general register
        R0  =0
        R1  =1
        R2  =2
        R3  =3
        R4  =4
        R5  =5
		
        '//stack pointer
        ESP =6
		
        '//instruction pointer
        EIP =7
		
        '//base pointer
        EBP =8
		
        '//segment pointer
        SEG = 9
		
        '//counter register
        ECP = 10
END ENUM

TYPE VMOPERANDE  FIELD=1
	FLAGS AS BYTE
    RegisterIndex as BYTE
	ImmediateOrDisplacement as Integer
END TYPE

TYPE VmInstructionBlock  FIELD=1
	Prefix as byte
	OPCODE as byte
	Padd1 as byte
	Padd2 as byte
	OPERANDE1 as VMOPERANDE
	OPERANDE2 as VMOPERANDE
end TYPE

TYPE RegistersMemory  FIELD=1
	R0 as Integer
	R1 as Integer
	R2 as Integer
	R3 as integer
	R4 as integer
	R5 as integer
	ESP as integer
	EIP as integer
	EBP as integer
	SEG as Integer
	ECP as integer
	EqualFlag as byte
	AboveFlag as byte
	OverflowFlag as byte
	ZeroFlag as byte
end TYPE





declare function VMOPERANDE_GetValue(op as VMOPERANDE, regs as RegistersMemory ptr) as INTEGER

