#include once "../../Include/Vm/VmStackMemory.bi"

function StackMemory_Create(stackSize as unsigned integer) as StackMemory ptr
	dim retval as StackMemory ptr
	retval =MEM_ALLOC(sizeof(StackMemory))
	retval->StackSize = stackSize
	retval->StackPointer = stackSize
	retval->Store = MEM_ALLOC(stackSize)
	StackMemory_Create=retval
end function

sub StackMemory_Destroy(theStack as StackMemory ptr)
	MEM_FREE(theStack->Store)
end sub	

sub StackMemory_Push32(theStack as StackMemory ptr,theVal as Integer)
	theStack->StackPointer = theStack->StackPointer-4
	theStack->Store[theStack->StackPointer] = theVal and &hFF
	theStack->Store[theStack->StackPointer+1] = (theVal shr 8) and &hFF
	theStack->Store[theStack->StackPointer+2] = (theVal shr 16) and &hFF
	theStack->Store[theStack->StackPointer+3] = (theVal shr 24) and &hFF
end sub

function StackMemory_Pop32(theStack as StackMemory ptr) as integer
	StackMemory_Pop32 = (theStack->Store[theStack->StackPointer+3] shl 24) or (theStack->Store[theStack->StackPointer+2] shl 16) or (theStack->Store[theStack->StackPointer+1] shl 8) or (theStack->Store[theStack->StackPointer])
	theStack->StackPointer = theStack->StackPointer+4
end function

sub StackMemory_Push16(theStack as StackMemory ptr,theVal as Short)
	theStack->StackPointer = theStack->StackPointer-2
	theStack->Store[theStack->StackPointer] = theVal and &hFF
	theStack->Store[theStack->StackPointer+1] = (theVal shr 8) and &hFF
end sub

function StackMemory_Pop16(theStack as StackMemory ptr) as Short
	StackMemory_Pop16 = (theStack->Store[theStack->StackPointer+1] shl 8) or (theStack->Store[theStack->StackPointer])
	theStack->StackPointer = theStack->StackPointer+2
end function

sub StackMemory_Push8(theStack as StackMemory ptr,theVal as byte)
	theStack->StackPointer = theStack->StackPointer-1
	theStack->Store[theStack->StackPointer] = theVal
end sub

function StackMemory_Pop8(theStack as StackMemory ptr) as byte
	StackMemory_Pop8 = (theStack->Store[theStack->StackPointer])
	theStack->StackPointer = theStack->StackPointer+1
end function

function StackMemory_Get32(theStack as StackMemory ptr,index as unsigned integer) as integer
	StackMemory_Get32 = (theStack->Store[index+3] shl 24) or (theStack->Store[index+2] shl 16) or (theStack->Store[index+1] shl 8) or (theStack->Store[index])
end function

function StackMemory_Get16(theStack as StackMemory ptr,index as unsigned integer) as short
	StackMemory_Get16 = (theStack->Store[index+1] shl 8) or (theStack->Store[index])
end function

function StackMemory_Get8(theStack as StackMemory ptr,index as unsigned integer) as byte
	StackMemory_Get8 = (theStack->Store[index])
end function

sub StackMemory_Set32(theStack as StackMemory ptr, theVal as integer, index as unsigned integer)
	theStack->Store[index] = theVal and &hFF
	theStack->Store[index+1] = (theVal shr 8) and &hFF
	theStack->Store[index+2] = (theVal shr 16) and &hFF
	theStack->Store[index+3] = (theVal shr 24) and &hFF
end sub

sub StackMemory_Set16(theStack as StackMemory ptr, theVal as short, index as unsigned integer)
	theStack->Store[index] = theVal and &hFF
	theStack->Store[index+1] = (theVal shr 8) and &hFF
end sub

sub StackMemory_Set8(theStack as StackMemory ptr, theVal as byte, index as unsigned integer)
	theStack->Store[index] = theVal and &hFF
end sub