#include once "../../Include/Vm/VmStackMemory.bi"
#include once "../../Include/Vm/VmThread.bi"


dim shared VmThread_HandlesSequence as integer
function VmThread_Create(mainProcess as VmProcess ptr) as VMThread ptr
	dim retval as VMThread ptr
	retval=MEM_ALLOC(sizeof(VMThread))
	retval->MainProcess = mainProcess
	retval->ThreadStack = StackMemory_Create(1024*1024)
	retval->ThreadRegs.R0=0
	retval->ThreadRegs.R1=0
	retval->ThreadRegs.R2=0
	retval->ThreadRegs.R3=0
	retval->ThreadRegs.R4=0
	retval->ThreadRegs.R5=0
	
	retval->ThreadRegs.ESP=retval->ThreadStack->StackPointer
	retval->ThreadRegs.EIP=0
	retval->ThreadRegs.EBP=0
	retval->ThreadRegs.SEG=0
	retval->ThreadRegs.ECP=0
	retval->ThreadRegs.EqualFlag=0
	retval->ThreadRegs.AboveFlag=0
	retval->ThreadRegs.OverflowFlag=0
	retval->ThreadRegs.ZeroFlag=0
	
	retval->MainProcess->Threads = LinkedList_AddItem(retval->MainProcess->Threads, retval)
	VmThread_HandlesSequence = VmThread_HandlesSequence+1
	retval->ThreadHandle=VmThread_HandlesSequence
	VmThread_Create= retval
end function

sub VmThread_Stop(theThread as VmThread ptr)
	LinkedList_RemoveItem(theThread->MainProcess->Threads, theThread)
	
	StackMemory_Destroy(theThread->ThreadStack)
	MEM_FREE(theThread->ThreadStack)
	MEM_FREE(theThread)
end sub