#include once "../Include/Console.bi"

dim shared consoleCursorX as integer
dim shared consoleCursorY as integer
dim shared consoleForeground as byte
dim shared consoleBackGround as byte

const consoleWidth=80
const consoleHeight=25

sub ConsoleInit()
    ConsoleSetForeground(15)
    ConsoleSetBackground(1)
    consoleCursorX=0
    consoleCursorY=0
    ConsoleClear()
end sub

sub ConsoleSetForeground(c as byte)
    consoleForeground=c
end sub

sub ConsoleSetBackground(c as byte)
    consoleBackGround=c
end sub

sub ConsoleWriteLine(src as byte ptr)
    ConsoleWrite(src)
    ConsoleNewLine()
end sub

sub putchar (c as byte)  
    dim dst as byte ptr
    dst = CPtr(Byte Ptr, &HB8000)
	
	dst[(consoleCursorY*consoleWidth+consoleCursorX)*2]=c
    dst[(consoleCursorY*consoleWidth+consoleCursorX)*2+1]=(consoleBackGround* 16 +consoleForeGround)
	consoleCursorX=consoleCursorX+1
    if (consoleCursorX>=consoleWidth) then ConsoleNewLine()
end sub

sub ConsoleWriteNumber(number as unsigned integer,abase as unsigned integer)
    const s="                "
    IntToStr(number,abase, cptr(byte ptr,@s))
    ConsoleWrite(CPtr(Byte Ptr, @s))
end sub

sub ConsoleWrite(src as byte ptr)
    
    dim cpt as integer
    dim dst as byte ptr
    dst = CPtr(Byte Ptr, &HB8000)
    cpt=0
    WHILE src[cpt] <> 0
        dst[(consoleCursorY*consoleWidth+consoleCursorX)*2]=src[cpt]
        dst[(consoleCursorY*consoleWidth+consoleCursorX)*2+1]=(consoleBackGround* 16 +consoleForeGround)
        consoleCursorX=consoleCursorX+1
        if (consoleCursorX>=consoleWidth) then ConsoleNewLine()
        cpt=cpt+1
    WEND
end sub

#include once "../Include/Console.bi"

sub IntToStr(number as unsigned integer, abase as unsigned integer, dest as byte ptr)
    
    dim numero as unsigned integer
    dim numero2 as unsigned integer
    dim digit as integer
    dim p as integer
    dim cpt as integer
    dim temp as byte
    p=32
	
	numero2=number
	while numero2>0
		numero=numero2 MOD abase
		if (numero<10) then
			dest[p]=numero+48
		else
			dest[p]=numero-10+65
        end if
		numero2=(numero2-numero)/abase
		p = p-1
	wend
    
    for cpt = 0 to 31-p
        temp=dest[p+1+cpt]
		dest[p+1+cpt]=dest[cpt]
		dest[cpt]=temp
    next
	dest[cpt]=0

end sub


sub ConsoleNewLine()
    consoleCursorX=0
    consoleCursorY=consoleCursorY+1
    if (consoleCursorY>=consoleHeight) then ConsoleScroll()
end sub


sub ConsoleClear()
    dim dst as byte ptr
    DST=cptr(byte ptr,&HB8000)
    dim counter as unsigned integer
	dim size as unsigned integer
	size=consoleWidth*consoleHeight*2
	counter=0
	while counter<size
        dst[counter]=0
		dst[counter+1]=(consoleBackGround* 16 +consoleForeGround)
		counter=counter+2
	wend
end sub

sub ConsoleScroll()
	dim y as integer
	dim x as integer
	dim scanLine as integer
	dim dst as byte ptr
    dst = CPtr(Byte Ptr, &HB8000)
	scanLine=consoleWidth*2
	
	y=0
	while y <consoleHeight-1
		x=0
		while x<scanLine
			dst[x]=dst[x+scanLine]
			x=x+1
		wend
		dst = dst+scanLine
		y=y+1
	WEND
	x=0
	while x<scanLine
		dst[x]=0
		dst[x+1]=(consoleBackGround* 16 +consoleForeGround)
		x=x+2
	wend
	consoleCursorY=consoleCursorY-1
end sub
 