#include once "../Include/MultiBoot.bi"
#include once "../Include/LinkedList.bi"

#include once "../Include/X86/gdt.bi"
#include once "../Include/Console.bi"
#include once "../Include/Mem.bi"

#include once "../Include/VM/VM.bi"
#include once "../Include/VM/VMProcess.bi"
#include once "../Include/VM/VMThread.bi"
#include once "../Include/VM/VMRuntime.bi"

declare sub PrintNumber(number as unsigned integer,abase as unsigned integer,x as long , y as long)
DECLARE SUB PrintString(src AS Byte Ptr, x AS LONG, y AS LONG)

DECLARE SUB main (mb_info as multiboot_info ptr)


'declare sub main()

extern KERNEL_END as unsigned integer

'0x10003
SUB multiboot ()
	Asm
		jmp multiboot_entry
		'setting up the Multiboot header - see GRUB docs for details
		.set FLAGS,    0x00000003
		.set MAGIC,    0x1BADB002       
		.set CHECKSUM, -(MAGIC + FLAGS) 
     
 
		.align 4
		Mboot:
		.LONG MAGIC
		.LONG FLAGS
		.LONG CHECKSUM
    
     
		.set STACKSIZE, 0x4000          
		.comm stack, STACKSIZE, 32      
 
		.global multiboot_entry                  
		.global Mboot
		.global system_halt
		
		multiboot_entry:
			cli
			lea   esp, stack + STACKSIZE
			                    
			push  ebx   
			CALL  MAIN
		system_halt:
			cli
			hlt    
		aloop:  jmp aloop
	END Asm
END SUB
 

 dim shared SystemIsRuning as integer
SUB main (mb_info as multiboot_info ptr)

    ConsoleInit()
    MEM_INIT(mb_info->mem_upper * 1024)
	GDT_INIT()
	
    ConsoleWriteLine(@"Kernel Ready")
	
	
END SUB

#include once "X86/gdt.bas"
#include once "Console.bas"
#include once "noarch/Mem.bas"
#include once "noarch/LinkedList.bas"
#include once "VM/VM.bas"