
dim shared MEM_BASE as MEM_HEADER ptr
dim shared OneMB as integer

sub MEM_INIT(totalMem as unsigned integer)
	OneMB = 1024*1024
	Dim Available as integer
	dim StartAddr as integer
	StartAddr=OneMB*10
	
	Available = totalMem-StartAddr
	MEM_BASE = cptr(MEM_HEADER ptr ,StartAddr)
	
    ConsoleWrite(@"Upper Memory : ")
    ConsoleWriteNumber(totalMem/OneMB,10)
	ConsoleWriteLine(@"MB")
	
	ConsoleWrite(@"Available    : ")
	ConsoleWriteNumber(Available/OneMB,10)
	ConsoleWriteLine(@"MB")
	ConsoleNewLine()
	
    MEM_BASE->FREE=1
    MEM_BASE->SIZE=Available - sizeof(MEM_HEADER)
    MEM_BASE->NEXT_BLOCK = 0
    MEM_BASE->PREV_BLOCK = 0
    
    
end sub

function MEM_ALLOC(ammount as unsigned integer) as any ptr
    dim needed as unsigned integer
    dim current_node as MEM_HEADER ptr
    dim new_node as MEM_HEADER ptr
    
	needed=ammount+sizeof(MEM_HEADER)
   
    current_node=cptr(MEM_HEADER ptr,MEM_BASE)
    
    while (current_node<>0) AND ((current_node->FREE=0) OR (current_node->SIZE<ammount))
        current_node=current_node->NEXT_BLOCK
    wend
    if (current_node<>0) THEN
        if (current_node->SIZE>needed+sizeof(MEM_HEADER)) then
			new_node=current_node+needed
			new_node->NEXT_BLOCK=current_node->NEXT_BLOCK
			new_node->PREV_BLOCK=current_node
			new_node->FREE=1
			new_node->SIZE=current_node->SIZE-needed
			current_node->FREE=0
			current_node->NEXT_BLOCK=new_node
			current_node->SIZE=ammount
		end if
        MEM_ALLOC=cptr(any ptr, CPTR(unsigned integer,current_node) +sizeof(MEM_HEADER))
		
    else
        MEM_ALLOC=0
    end if
end function

sub MEM_FREE(addr as any ptr)
     dim node as MEM_HEADER ptr
     dim headerSize as unsigned integer
     headerSize=sizeof(MEM_HEADER)
     node =CPTR(MEM_HEADER ptr, addr-headerSize)
     node->FREE=1
	 
     while (node->NEXT_BLOCK<>0 AND node->NEXT_BLOCK->FREE=1)
         node->SIZE         = node->SIZE + node->NEXT_BLOCK->SIZE + headerSize
         node->NEXT_BLOCK   = node->NEXT_BLOCK->NEXT_BLOCK
     wend
     while (node->PREV_BLOCK<>0 and node->PREV_BLOCK->FREE=1)
         node->PREV_BLOCK->SIZE = node->PREV_BLOCK->SIZE + node->SIZE + headerSize
         node->PREV_BLOCK->NEXT_BLOCK => node->NEXT_BLOCK
         node=node->PREV_BLOCK
     wend
end sub

function MEM_REALLOC(addr as any ptr, newsize as unsigned integer) as any ptr
	dim retval as any ptr
	retval=MEM_ALLOC(newsize)
	dim oldsize as unsigned integer
	oldsize = cptr(MEM_HEADER ptr, cast(unsigned integer,addr) - sizeof(MEM_HEADER))->SIZE
	if (oldsize<newsize) then 
		MEM_CPY(addr,retval,oldsize)
	else 
		MEM_CPY(addr,retval,newsize)
	end if
	MEM_REALLOC=retval
end function

sub MEM_CPY(src as any ptr, dst as any ptr,cpt as unsigned integer)
	dim i as unsigned integer
	i=0
	dim d as byte ptr
	dim s as byte ptr
	d=cptr(byte ptr,dst)
	s=cptr(byte ptr,src)
	while i<cpt
		d[cpt]=s[cpt]
		i=i+1
	wend
end sub