dim shared gdt_nbr_segment as unsigned integer
dim shared gdt as gdt_entry ptr
dim shared gp as gdt_ptr

SUB GDT_INIT()
	ConsoleWrite(@"Initializing GDT ... ")
	dim nbr as unsigned integer
	
	gdt = MEM_ALLOC(256 * sizeof(gdt_entry))
	
    gp.thelimit = (sizeof(gdt_entry) * 256) - 1
    gp.thebase = cast(unsigned integer,gdt)
	
    '==gdt_set_gate(0, 0, 0, 0, 0) ==
    gdt_set_gate(1, 0, &hFFFFFFFF, &h9A, &hCF)
    gdt_set_gate(2, 0, &hFFFFFFFF, &h92, &hCF)
	
    nbr=gdt_create_seg(0,0,0,0)
    nbr=gdt_create_seg(0,&hffffffff,&h9a,&hcf)	'0x8
    nbr=gdt_create_seg(0,&hffffffff,&h92,&hcf)	'0x10
    nbr=gdt_create_seg(0,&h0000ffff,&h9A,0)		'0x18
    nbr=gdt_create_seg(0,&h0000ffff,&h92,0)		'0x20
    ASM
	gdt_flush:
		lgdt [gp]
		jmp 0x8:flushed
		flushed:
		
		mov ax,0x10
		mov ds,ax 
		mov es,ax
		mov fs,ax
		mov gs,ax
		mov ss,ax
	END ASM
	ConsoleWriteLine(@"DONE")
END SUB


function gdt_create_seg(thebase as unsigned integer,thelimit as unsigned integer, theaccess as byte, thegran as byte) as unsigned integer
    gdt_set_gate(gdt_nbr_segment, thebase, thelimit, theaccess, thegran)
	gdt_nbr_segment = gdt_nbr_segment+1
    gdt_create_seg =  gdt_nbr_segment
	
end function

sub gdt_set_gate(num as unsigned integer,thebase as unsigned integer, thelimit as unsigned integer, theaccess as byte, thegran as byte)
    '== Setup the descriptor base address ==
    gdt[num].base_low = (thebase and &hFFFF)
    gdt[num].base_middle = (thebase shr 16) and &hFF
    gdt[num].base_high = (thebase shr 24) and &hFF

    '== Setup the descriptor limits ==
    gdt[num].limit_low = (thelimit and &hFFFF)
    gdt[num].granularity = ((thelimit shr 16) and &h0F)

    '== Finally, set up the granularity and access flags ==
    gdt[num].granularity =gdt[num].granularity or (thegran and &hF0)
    gdt[num].access = theaccess
end sub